//////////////////////////////////////////
//
// NOTE: This is *not* a valid shader file
//
///////////////////////////////////////////
Shader "Sprites/Default" {
    Properties {
        _MainTex ("Sprite Texture", 2D) = "white" { }
        _Color ("Tint", Color) = (1,1,1,1)
        [MaterialToggle] PixelSnap ("Pixel snap", Float) = 0
        _RendererColor ("RendererColor", Color) = (1,1,1,1)
        _Flip ("Flip", Vector) = (1,1,1,1)
        _AlphaTex ("External Alpha", 2D) = "white" { }
        _EnableExternalAlpha ("Enable External Alpha", Float) = 0
    }
    SubShader {
        Tags { "CanUseSpriteAtlas" = "true" "IGNOREPROJECTOR" = "true" "PreviewType" = "Plane" "QUEUE" = "Transparent" "RenderType" = "Transparent" }
        Pass {
            Tags { "CanUseSpriteAtlas" = "true" "IGNOREPROJECTOR" = "true" "PreviewType" = "Plane" "QUEUE" = "Transparent" "RenderType" = "Transparent" }
            Blend One OneMinusSrcAlpha, One OneMinusSrcAlpha
            ZWrite Off
            Cull Off
            GpuProgramID 1368
            PlayerProgram "vp" {
                SubProgram "gles3 " {
                    "#ifdef VERTEX
                    #version 300 es
                    
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	vec4 hlslcc_mtx4x4unity_ObjectToWorld[4];
                    uniform 	vec4 hlslcc_mtx4x4unity_MatrixVP[4];
                    uniform 	mediump vec4 _RendererColor;
                    uniform 	mediump vec2 _Flip;
                    uniform 	mediump vec4 _Color;
                    in highp vec4 in_POSITION0;
                    in highp vec4 in_COLOR0;
                    in highp vec2 in_TEXCOORD0;
                    out mediump vec4 vs_COLOR0;
                    out highp vec2 vs_TEXCOORD0;
                    vec4 u_xlat0;
                    vec4 u_xlat1;
                    void main()
                    {
                        u_xlat0.xy = in_POSITION0.xy * _Flip.xy;
                        u_xlat1 = u_xlat0.yyyy * hlslcc_mtx4x4unity_ObjectToWorld[1];
                        u_xlat0 = hlslcc_mtx4x4unity_ObjectToWorld[0] * u_xlat0.xxxx + u_xlat1;
                        u_xlat0 = hlslcc_mtx4x4unity_ObjectToWorld[2] * in_POSITION0.zzzz + u_xlat0;
                        u_xlat0 = u_xlat0 + hlslcc_mtx4x4unity_ObjectToWorld[3];
                        u_xlat1 = u_xlat0.yyyy * hlslcc_mtx4x4unity_MatrixVP[1];
                        u_xlat1 = hlslcc_mtx4x4unity_MatrixVP[0] * u_xlat0.xxxx + u_xlat1;
                        u_xlat1 = hlslcc_mtx4x4unity_MatrixVP[2] * u_xlat0.zzzz + u_xlat1;
                        gl_Position = hlslcc_mtx4x4unity_MatrixVP[3] * u_xlat0.wwww + u_xlat1;
                        u_xlat0 = in_COLOR0 * _Color;
                        u_xlat0 = u_xlat0 * _RendererColor;
                        vs_COLOR0 = u_xlat0;
                        vs_TEXCOORD0.xy = in_TEXCOORD0.xy;
                        return;
                    }
                    
                    #endif
                    #ifdef FRAGMENT
                    #version 300 es
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    #extension GL_EXT_shader_framebuffer_fetch : enable
                    #endif
                    
                    precision highp float;
                    precision highp int;
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    UNITY_LOCATION(0) uniform mediump sampler2D _MainTex;
                    in mediump vec4 vs_COLOR0;
                    in highp vec2 vs_TEXCOORD0;
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    layout(location = 0) inout mediump vec4 SV_Target0;
                    #else
                    layout(location = 0) out mediump vec4 SV_Target0;
                    #endif
                    vec4 u_xlat0;
                    mediump vec4 u_xlat16_0;
                    void main()
                    {
                        u_xlat0 = texture(_MainTex, vs_TEXCOORD0.xy);
                        u_xlat16_0 = u_xlat0 * vs_COLOR0;
                        SV_Target0.xyz = u_xlat16_0.www * u_xlat16_0.xyz;
                        SV_Target0.w = u_xlat16_0.w;
                        return;
                    }
                    
                    #endif
                    "
                }
                SubProgram "gles3 " {
                    Keywords { "PIXELSNAP_ON" }
                    "#ifdef VERTEX
                    #version 300 es
                    
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	vec4 _ScreenParams;
                    uniform 	vec4 hlslcc_mtx4x4unity_ObjectToWorld[4];
                    uniform 	vec4 hlslcc_mtx4x4unity_MatrixVP[4];
                    uniform 	mediump vec4 _RendererColor;
                    uniform 	mediump vec2 _Flip;
                    uniform 	mediump vec4 _Color;
                    in highp vec4 in_POSITION0;
                    in highp vec4 in_COLOR0;
                    in highp vec2 in_TEXCOORD0;
                    out mediump vec4 vs_COLOR0;
                    out highp vec2 vs_TEXCOORD0;
                    vec4 u_xlat0;
                    vec4 u_xlat1;
                    void main()
                    {
                        u_xlat0.xy = in_POSITION0.xy * _Flip.xy;
                        u_xlat1 = u_xlat0.yyyy * hlslcc_mtx4x4unity_ObjectToWorld[1];
                        u_xlat0 = hlslcc_mtx4x4unity_ObjectToWorld[0] * u_xlat0.xxxx + u_xlat1;
                        u_xlat0 = hlslcc_mtx4x4unity_ObjectToWorld[2] * in_POSITION0.zzzz + u_xlat0;
                        u_xlat0 = u_xlat0 + hlslcc_mtx4x4unity_ObjectToWorld[3];
                        u_xlat1 = u_xlat0.yyyy * hlslcc_mtx4x4unity_MatrixVP[1];
                        u_xlat1 = hlslcc_mtx4x4unity_MatrixVP[0] * u_xlat0.xxxx + u_xlat1;
                        u_xlat1 = hlslcc_mtx4x4unity_MatrixVP[2] * u_xlat0.zzzz + u_xlat1;
                        u_xlat0 = hlslcc_mtx4x4unity_MatrixVP[3] * u_xlat0.wwww + u_xlat1;
                        u_xlat0.xy = u_xlat0.xy / u_xlat0.ww;
                        u_xlat1.xy = _ScreenParams.xy * vec2(0.5, 0.5);
                        u_xlat0.xy = u_xlat0.xy * u_xlat1.xy;
                        u_xlat0.xy = roundEven(u_xlat0.xy);
                        u_xlat0.xy = u_xlat0.xy / u_xlat1.xy;
                        gl_Position.xy = u_xlat0.ww * u_xlat0.xy;
                        gl_Position.zw = u_xlat0.zw;
                        u_xlat0 = in_COLOR0 * _Color;
                        u_xlat0 = u_xlat0 * _RendererColor;
                        vs_COLOR0 = u_xlat0;
                        vs_TEXCOORD0.xy = in_TEXCOORD0.xy;
                        return;
                    }
                    
                    #endif
                    #ifdef FRAGMENT
                    #version 300 es
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    #extension GL_EXT_shader_framebuffer_fetch : enable
                    #endif
                    
                    precision highp float;
                    precision highp int;
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    UNITY_LOCATION(0) uniform mediump sampler2D _MainTex;
                    in mediump vec4 vs_COLOR0;
                    in highp vec2 vs_TEXCOORD0;
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    layout(location = 0) inout mediump vec4 SV_Target0;
                    #else
                    layout(location = 0) out mediump vec4 SV_Target0;
                    #endif
                    vec4 u_xlat0;
                    mediump vec4 u_xlat16_0;
                    void main()
                    {
                        u_xlat0 = texture(_MainTex, vs_TEXCOORD0.xy);
                        u_xlat16_0 = u_xlat0 * vs_COLOR0;
                        SV_Target0.xyz = u_xlat16_0.www * u_xlat16_0.xyz;
                        SV_Target0.w = u_xlat16_0.w;
                        return;
                    }
                    
                    #endif
                    "
                }
                SubProgram "gles3 " {
                    Keywords { "ETC1_EXTERNAL_ALPHA" }
                    "#ifdef VERTEX
                    #version 300 es
                    
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	vec4 hlslcc_mtx4x4unity_ObjectToWorld[4];
                    uniform 	vec4 hlslcc_mtx4x4unity_MatrixVP[4];
                    uniform 	mediump vec4 _RendererColor;
                    uniform 	mediump vec2 _Flip;
                    uniform 	mediump vec4 _Color;
                    in highp vec4 in_POSITION0;
                    in highp vec4 in_COLOR0;
                    in highp vec2 in_TEXCOORD0;
                    out mediump vec4 vs_COLOR0;
                    out highp vec2 vs_TEXCOORD0;
                    vec4 u_xlat0;
                    vec4 u_xlat1;
                    void main()
                    {
                        u_xlat0.xy = in_POSITION0.xy * _Flip.xy;
                        u_xlat1 = u_xlat0.yyyy * hlslcc_mtx4x4unity_ObjectToWorld[1];
                        u_xlat0 = hlslcc_mtx4x4unity_ObjectToWorld[0] * u_xlat0.xxxx + u_xlat1;
                        u_xlat0 = hlslcc_mtx4x4unity_ObjectToWorld[2] * in_POSITION0.zzzz + u_xlat0;
                        u_xlat0 = u_xlat0 + hlslcc_mtx4x4unity_ObjectToWorld[3];
                        u_xlat1 = u_xlat0.yyyy * hlslcc_mtx4x4unity_MatrixVP[1];
                        u_xlat1 = hlslcc_mtx4x4unity_MatrixVP[0] * u_xlat0.xxxx + u_xlat1;
                        u_xlat1 = hlslcc_mtx4x4unity_MatrixVP[2] * u_xlat0.zzzz + u_xlat1;
                        gl_Position = hlslcc_mtx4x4unity_MatrixVP[3] * u_xlat0.wwww + u_xlat1;
                        u_xlat0 = in_COLOR0 * _Color;
                        u_xlat0 = u_xlat0 * _RendererColor;
                        vs_COLOR0 = u_xlat0;
                        vs_TEXCOORD0.xy = in_TEXCOORD0.xy;
                        return;
                    }
                    
                    #endif
                    #ifdef FRAGMENT
                    #version 300 es
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    #extension GL_EXT_shader_framebuffer_fetch : enable
                    #endif
                    
                    precision highp float;
                    precision highp int;
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	float _EnableExternalAlpha;
                    UNITY_LOCATION(0) uniform mediump sampler2D _MainTex;
                    UNITY_LOCATION(1) uniform mediump sampler2D _AlphaTex;
                    in mediump vec4 vs_COLOR0;
                    in highp vec2 vs_TEXCOORD0;
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    layout(location = 0) inout mediump vec4 SV_Target0;
                    #else
                    layout(location = 0) out mediump vec4 SV_Target0;
                    #endif
                    float u_xlat0;
                    mediump vec4 u_xlat16_0;
                    vec4 u_xlat1;
                    void main()
                    {
                        u_xlat0 = texture(_AlphaTex, vs_TEXCOORD0.xy).x;
                        u_xlat1 = texture(_MainTex, vs_TEXCOORD0.xy);
                        u_xlat0 = u_xlat0 + (-u_xlat1.w);
                        u_xlat1.w = _EnableExternalAlpha * u_xlat0 + u_xlat1.w;
                        u_xlat16_0 = u_xlat1 * vs_COLOR0;
                        SV_Target0.xyz = u_xlat16_0.www * u_xlat16_0.xyz;
                        SV_Target0.w = u_xlat16_0.w;
                        return;
                    }
                    
                    #endif
                    "
                }
                SubProgram "gles3 " {
                    Keywords { "ETC1_EXTERNAL_ALPHA" "PIXELSNAP_ON" }
                    "#ifdef VERTEX
                    #version 300 es
                    
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	vec4 _ScreenParams;
                    uniform 	vec4 hlslcc_mtx4x4unity_ObjectToWorld[4];
                    uniform 	vec4 hlslcc_mtx4x4unity_MatrixVP[4];
                    uniform 	mediump vec4 _RendererColor;
                    uniform 	mediump vec2 _Flip;
                    uniform 	mediump vec4 _Color;
                    in highp vec4 in_POSITION0;
                    in highp vec4 in_COLOR0;
                    in highp vec2 in_TEXCOORD0;
                    out mediump vec4 vs_COLOR0;
                    out highp vec2 vs_TEXCOORD0;
                    vec4 u_xlat0;
                    vec4 u_xlat1;
                    void main()
                    {
                        u_xlat0.xy = in_POSITION0.xy * _Flip.xy;
                        u_xlat1 = u_xlat0.yyyy * hlslcc_mtx4x4unity_ObjectToWorld[1];
                        u_xlat0 = hlslcc_mtx4x4unity_ObjectToWorld[0] * u_xlat0.xxxx + u_xlat1;
                        u_xlat0 = hlslcc_mtx4x4unity_ObjectToWorld[2] * in_POSITION0.zzzz + u_xlat0;
                        u_xlat0 = u_xlat0 + hlslcc_mtx4x4unity_ObjectToWorld[3];
                        u_xlat1 = u_xlat0.yyyy * hlslcc_mtx4x4unity_MatrixVP[1];
                        u_xlat1 = hlslcc_mtx4x4unity_MatrixVP[0] * u_xlat0.xxxx + u_xlat1;
                        u_xlat1 = hlslcc_mtx4x4unity_MatrixVP[2] * u_xlat0.zzzz + u_xlat1;
                        u_xlat0 = hlslcc_mtx4x4unity_MatrixVP[3] * u_xlat0.wwww + u_xlat1;
                        u_xlat0.xy = u_xlat0.xy / u_xlat0.ww;
                        u_xlat1.xy = _ScreenParams.xy * vec2(0.5, 0.5);
                        u_xlat0.xy = u_xlat0.xy * u_xlat1.xy;
                        u_xlat0.xy = roundEven(u_xlat0.xy);
                        u_xlat0.xy = u_xlat0.xy / u_xlat1.xy;
                        gl_Position.xy = u_xlat0.ww * u_xlat0.xy;
                        gl_Position.zw = u_xlat0.zw;
                        u_xlat0 = in_COLOR0 * _Color;
                        u_xlat0 = u_xlat0 * _RendererColor;
                        vs_COLOR0 = u_xlat0;
                        vs_TEXCOORD0.xy = in_TEXCOORD0.xy;
                        return;
                    }
                    
                    #endif
                    #ifdef FRAGMENT
                    #version 300 es
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    #extension GL_EXT_shader_framebuffer_fetch : enable
                    #endif
                    
                    precision highp float;
                    precision highp int;
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	float _EnableExternalAlpha;
                    UNITY_LOCATION(0) uniform mediump sampler2D _MainTex;
                    UNITY_LOCATION(1) uniform mediump sampler2D _AlphaTex;
                    in mediump vec4 vs_COLOR0;
                    in highp vec2 vs_TEXCOORD0;
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    layout(location = 0) inout mediump vec4 SV_Target0;
                    #else
                    layout(location = 0) out mediump vec4 SV_Target0;
                    #endif
                    float u_xlat0;
                    mediump vec4 u_xlat16_0;
                    vec4 u_xlat1;
                    void main()
                    {
                        u_xlat0 = texture(_AlphaTex, vs_TEXCOORD0.xy).x;
                        u_xlat1 = texture(_MainTex, vs_TEXCOORD0.xy);
                        u_xlat0 = u_xlat0 + (-u_xlat1.w);
                        u_xlat1.w = _EnableExternalAlpha * u_xlat0 + u_xlat1.w;
                        u_xlat16_0 = u_xlat1 * vs_COLOR0;
                        SV_Target0.xyz = u_xlat16_0.www * u_xlat16_0.xyz;
                        SV_Target0.w = u_xlat16_0.w;
                        return;
                    }
                    
                    #endif
                    "
                }
            }
        }
    }
}